'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Inc.
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var MultisigActions = function () {
  function MultisigActions(multisigWrapper, multiplexerWrapper) {
    (0, _classCallCheck3.default)(this, MultisigActions);

    this.multisigWrapper = multisigWrapper;
    this.multiplexerWrapper = multiplexerWrapper;
  }

  (0, _createClass3.default)(MultisigActions, [{
    key: 'getTransactionCallFromData',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(transactionId) {
        var _ref2, data, name, args;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.multisigWrapper.getTransaction(transactionId);

              case 2:
                _ref2 = _context.sent;
                data = _ref2.data;
                name = this.multiplexerWrapper.getFunctionName(data);
                args = this.multiplexerWrapper.getFunctionArguments(data);
                return _context.abrupt('return', { name: name, args: args, transactionId: transactionId });

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getTransactionCallFromData(_x) {
        return _ref.apply(this, arguments);
      }

      return getTransactionCallFromData;
    }()
  }, {
    key: 'allPendingTransactions',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var allPendingTransactionIds, allPendingTransactions, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, txId;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.multisigWrapper.getPendingTransaction();

              case 2:
                allPendingTransactionIds = _context2.sent;
                allPendingTransactions = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context2.prev = 7;
                _iterator = allPendingTransactionIds[Symbol.iterator]();

              case 9:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context2.next = 19;
                  break;
                }

                txId = _step.value;
                _context2.t0 = allPendingTransactions;
                _context2.next = 14;
                return this.getTransactionCallFromData(txId);

              case 14:
                _context2.t1 = _context2.sent;

                _context2.t0.push.call(_context2.t0, _context2.t1);

              case 16:
                _iteratorNormalCompletion = true;
                _context2.next = 9;
                break;

              case 19:
                _context2.next = 25;
                break;

              case 21:
                _context2.prev = 21;
                _context2.t2 = _context2['catch'](7);
                _didIteratorError = true;
                _iteratorError = _context2.t2;

              case 25:
                _context2.prev = 25;
                _context2.prev = 26;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 28:
                _context2.prev = 28;

                if (!_didIteratorError) {
                  _context2.next = 31;
                  break;
                }

                throw _iteratorError;

              case 31:
                return _context2.finish(28);

              case 32:
                return _context2.finish(25);

              case 33:
                return _context2.abrupt('return', allPendingTransactions);

              case 34:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[7, 21, 25, 33], [26,, 28, 32]]);
      }));

      function allPendingTransactions() {
        return _ref3.apply(this, arguments);
      }

      return allPendingTransactions;
    }()
  }, {
    key: 'approvableTransactions',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var allPendingTransactionIds, approvableTransactions, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, txId, confirmations;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.multisigWrapper.getPendingTransaction();

              case 2:
                allPendingTransactionIds = _context3.sent;
                approvableTransactions = [];
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context3.prev = 7;
                _iterator2 = allPendingTransactionIds[Symbol.iterator]();

              case 9:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context3.next = 23;
                  break;
                }

                txId = _step2.value;
                _context3.next = 13;
                return this.multisigWrapper.getConfirmations(txId);

              case 13:
                confirmations = _context3.sent;

                if (confirmations.includes(this.multisigWrapper.defaultAddress)) {
                  _context3.next = 20;
                  break;
                }

                _context3.t0 = approvableTransactions;
                _context3.next = 18;
                return this.getTransactionCallFromData(txId);

              case 18:
                _context3.t1 = _context3.sent;

                _context3.t0.push.call(_context3.t0, _context3.t1);

              case 20:
                _iteratorNormalCompletion2 = true;
                _context3.next = 9;
                break;

              case 23:
                _context3.next = 29;
                break;

              case 25:
                _context3.prev = 25;
                _context3.t2 = _context3['catch'](7);
                _didIteratorError2 = true;
                _iteratorError2 = _context3.t2;

              case 29:
                _context3.prev = 29;
                _context3.prev = 30;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 32:
                _context3.prev = 32;

                if (!_didIteratorError2) {
                  _context3.next = 35;
                  break;
                }

                throw _iteratorError2;

              case 35:
                return _context3.finish(32);

              case 36:
                return _context3.finish(29);

              case 37:
                return _context3.abrupt('return', approvableTransactions);

              case 38:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[7, 25, 29, 37], [30,, 32, 36]]);
      }));

      function approvableTransactions() {
        return _ref4.apply(this, arguments);
      }

      return approvableTransactions;
    }()
  }, {
    key: 'submitTransactionToMultiplexer',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(data) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this.multisigWrapper.submitTransaction(this.multiplexerWrapper.address(), '0', data));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function submitTransactionToMultiplexer(_x2) {
        return _ref5.apply(this, arguments);
      }

      return submitTransactionToMultiplexer;
    }()
  }, {
    key: 'transferMultiplexerOwnership',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(address) {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.t0 = this;
                _context5.next = 3;
                return this.multiplexerWrapper.transferOwnership(address);

              case 3:
                _context5.t1 = _context5.sent;
                return _context5.abrupt('return', _context5.t0.submitTransactionToMultiplexer.call(_context5.t0, _context5.t1));

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function transferMultiplexerOwnership(_x3) {
        return _ref6.apply(this, arguments);
      }

      return transferMultiplexerOwnership;
    }()
  }, {
    key: 'transferContractsOwnership',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(address) {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.t0 = this;
                _context6.next = 3;
                return this.multiplexerWrapper.transferContractsOwnership(address);

              case 3:
                _context6.t1 = _context6.sent;
                return _context6.abrupt('return', _context6.t0.submitTransactionToMultiplexer.call(_context6.t0, _context6.t1));

              case 5:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function transferContractsOwnership(_x4) {
        return _ref7.apply(this, arguments);
      }

      return transferContractsOwnership;
    }()
  }, {
    key: 'changeContext',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(contextAddress) {
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.t0 = this;
                _context7.next = 3;
                return this.multiplexerWrapper.changeContext(contextAddress);

              case 3:
                _context7.t1 = _context7.sent;
                return _context7.abrupt('return', _context7.t0.submitTransactionToMultiplexer.call(_context7.t0, _context7.t1));

              case 5:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function changeContext(_x5) {
        return _ref8.apply(this, arguments);
      }

      return changeContext;
    }()
  }, {
    key: 'addToWhitelist',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(candidateAddress, role, deposit) {
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.t0 = this;
                _context8.next = 3;
                return this.multiplexerWrapper.addToWhitelist(candidateAddress, role, deposit);

              case 3:
                _context8.t1 = _context8.sent;
                return _context8.abrupt('return', _context8.t0.submitTransactionToMultiplexer.call(_context8.t0, _context8.t1));

              case 5:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function addToWhitelist(_x6, _x7, _x8) {
        return _ref9.apply(this, arguments);
      }

      return addToWhitelist;
    }()
  }, {
    key: 'removeFromWhitelist',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(candidateAddress) {
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.t0 = this;
                _context9.next = 3;
                return this.multiplexerWrapper.removeFromWhitelist(candidateAddress);

              case 3:
                _context9.t1 = _context9.sent;
                return _context9.abrupt('return', _context9.t0.submitTransactionToMultiplexer.call(_context9.t0, _context9.t1));

              case 5:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function removeFromWhitelist(_x9) {
        return _ref10.apply(this, arguments);
      }

      return removeFromWhitelist;
    }()
  }, {
    key: 'setBaseUploadFee',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(fee) {
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.t0 = this;
                _context10.next = 3;
                return this.multiplexerWrapper.setBaseUploadFee(fee);

              case 3:
                _context10.t1 = _context10.sent;
                return _context10.abrupt('return', _context10.t0.submitTransactionToMultiplexer.call(_context10.t0, _context10.t1));

              case 5:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function setBaseUploadFee(_x10) {
        return _ref11.apply(this, arguments);
      }

      return setBaseUploadFee;
    }()
  }, {
    key: 'transferOwnershipForValidatorSet',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(address) {
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.t0 = this;
                _context11.next = 3;
                return this.multiplexerWrapper.transferOwnershipForValidatorSet(address);

              case 3:
                _context11.t1 = _context11.sent;
                return _context11.abrupt('return', _context11.t0.submitTransactionToMultiplexer.call(_context11.t0, _context11.t1));

              case 5:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function transferOwnershipForValidatorSet(_x11) {
        return _ref12.apply(this, arguments);
      }

      return transferOwnershipForValidatorSet;
    }()
  }, {
    key: 'transferOwnershipForBlockRewards',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12(address) {
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.t0 = this;
                _context12.next = 3;
                return this.multiplexerWrapper.transferOwnershipForBlockRewards(address);

              case 3:
                _context12.t1 = _context12.sent;
                return _context12.abrupt('return', _context12.t0.submitTransactionToMultiplexer.call(_context12.t0, _context12.t1));

              case 5:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function transferOwnershipForBlockRewards(_x12) {
        return _ref13.apply(this, arguments);
      }

      return transferOwnershipForBlockRewards;
    }()
  }, {
    key: 'confirmTransaction',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee13(transactionId) {
        return _regenerator2.default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                return _context13.abrupt('return', this.multisigWrapper.confirmTransaction(transactionId));

              case 1:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function confirmTransaction(_x13) {
        return _ref14.apply(this, arguments);
      }

      return confirmTransaction;
    }()
  }, {
    key: 'revokeConfirmation',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee14(transactionId) {
        return _regenerator2.default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                return _context14.abrupt('return', this.multisigWrapper.revokeConfirmation(transactionId));

              case 1:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function revokeConfirmation(_x14) {
        return _ref15.apply(this, arguments);
      }

      return revokeConfirmation;
    }()
  }]);
  return MultisigActions;
}();

exports.default = MultisigActions;